#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;


int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int min_len = atoi(argv[2]);
	int max_len = atoi(argv[3]);
	int min_bet = atoi(argv[4]);
	int max_bet = atoi(argv[5]);
	int cnt_try = atoi(argv[6]);
	int sorted = atoi(argv[7]);

	vector<int> intervals;
	vector<int> other;

	int ptr = 0;

	
	while (ptr < n)
	{
		int new_len = min(n - ptr, rnd.next(min_len, max_len));
		int new_bet = min(n - ptr - new_len, rnd.next(min_bet, max_bet));

		for (int mem = ptr + new_len; ptr < mem; ++ptr)
		{
			intervals.push_back(ptr);
		}
		
		vector<int> now;
		for (int mem = ptr + new_bet; ptr < mem; ++ptr)
		{
			now.push_back(ptr);
		}
		shuffle(now.begin(), now.end());
		for (int i = 0; i < (int)now.size(); ++i)
		{
			other.push_back(now[i]);
		}
	}

	shuffle(intervals.begin(), intervals.end());
	
	if (sorted == 0)
	{
		shuffle(other.begin(), other.end());
	}
	else if (sorted == 1)
	{
		sort(other.begin(), other.end());
	}
	else
	{
		//sort(other.begin(), other.end());
		reverse(other.begin(), other.end());
	}
	
	int intervals_ptr = 0;
	set<int> sort_intervals(intervals.begin(), intervals.end());

	vector<int> p;
	for (int i = 0; i < (int)other.size(); ++i)
	{
		vector<int> need;
		while (!sort_intervals.empty() && *sort_intervals.rbegin() > other[i]) 
		{
			need.push_back(*sort_intervals.rbegin());
			sort_intervals.erase(*sort_intervals.rbegin());
		}
		shuffle(need.begin(), need.end());
		for (int j = 0; j < (int)need.size(); ++j)
		{
			p.push_back(need[j] + 1);
		}
		for (int j = 0; j < cnt_try && !sort_intervals.empty(); ++j)
		{
			int x = rnd.next(1, n);
			auto it = sort_intervals.lower_bound(x);
			if (it != sort_intervals.end())
			{
				p.push_back(*it + 1);
				sort_intervals.erase(*it);
			}
		}
		p.push_back(other[i] + 1);
	}

	while (!sort_intervals.empty()) 
	{
		p.push_back(*sort_intervals.rbegin() + 1);
		sort_intervals.erase(*sort_intervals.rbegin());
	}

	assert((int)p.size() == n);
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
	{
		printf("%d%c", p[i], " \n"[i == n - 1]);
	}

	return 0;
}


