#include "testlib.h"

int SumOfDigits(int x) {
  int sum = 0;
  while (x) {
    sum += x % 10;
    x /= 10;
  }
  return sum;
}

int n;

inline int ReadAndCheckAnswer(InStream& in) {
  int result = in.readInt(0, n);
  if (result == 0) {
    return result;
  }

  int sum = result + SumOfDigits(result);
  if (sum != n) {
    in.quitf(_wa, "Sum %d is not equal to n", sum);
  }

  return result;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);

  n = inf.readInt();

  int ja = ReadAndCheckAnswer(ans);
  int pa = ReadAndCheckAnswer(ouf);

  if (ja != 0 && pa == 0)
    quitf(_wa, "Jury has the answer but participant has not");
  if (ja == 0 && pa != 0)
    quitf(_fail, "Participant has the answer but jury has not");

  quitf(_ok, "n=%d", n);
}
