#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100 * 1000 + 7;

int p[MAXN], q[MAXN], u[MAXN], v[MAXN];
bool path[MAXN];
vector<pair<int, int> > g[MAXN];

void dfs(int v, int n, int p) {
	if (v == n) {
		path[v] = true;
	} else {
		for (auto ee : g[v]) {
			int to = ee.first;
			if (to != p) {
				dfs(to, n, v);
				path[v] |= path[to];
			}
		}
	}
}

vector<int> e;

void go(int v, int p) {
	for (auto ee : g[v]) {
		int to = ee.first;
		if (to != p && !path[to]) {
			e.push_back(ee.second);
			go(to, v);
		}
	}
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int n;
	scanf("%d", &n);
	for (int i = 1; i < n; i++) {
		scanf("%d %d", &u[i], &v[i]);
		g[u[i]].emplace_back(v[i], i);
		g[v[i]].emplace_back(u[i], i);
	}
	dfs(1, n, -1);
	for (int i = 1; i <= n; i++) {
		if (!path[i]) continue;
			e.clear();
			go(i, -1);
			for (int x : e) {
				p[x] = rnd.next(-10, -1);
				q[x] = rnd.next(-10, -1);
			}
			if (e.size()) {
			    int pos = rnd.next(0, (int)e.size() - 1);
			    if (rnd.next(0, 1)) {
				    p[pos] = rnd.next(1, (int)1e4);
			    } else {
				    q[pos] = rnd.next(1, (int)1e4);
			    }
			}
	}
	for (int i = 1; i < n; i++) {
		if (p[i] == 0 && q[i] == 0) {
			p[i] = rnd.next(-(int)1e4, (int)1e4);
			q[i] = rnd.next(-(int)1e4, (int)1e4);
		}
	}
	printf("%d\n", n);
	for (int i = 1; i < n; i++) {
		printf("%d %d %d %d\n", u[i], v[i], p[i], q[i]);
	}
	return 0;
}