#include "testlib.h"
#include <bits/stdc++.h>


constexpr size_t MAX_N = 100 * 1000;

constexpr int32_t MAX_W = 10 * 1000;

class DisjointSetUnion {
private:
    size_t n;
    std::vector<size_t> parent, weight;

    size_t getParent(size_t v) {
      if (parent[v] == n + 1) {
        return v;
      }
      parent[v] = getParent(parent[v]);
      return parent[v];
    }
public:
    explicit DisjointSetUnion(size_t n) : n(n) {
      parent.resize(n, n + 1);
      weight.resize(n, 1);
    }

    bool join(size_t u, size_t v) {
      u = getParent(u);
      v = getParent(v);
      if (u == v) {
        return false;
      }
      if (weight[u] < weight[v]) {
        std::swap(u, v);
      }
      parent[v] = u;
      weight[u] += weight[v];
      return true;
    }
};

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  size_t n = inf.readUnsignedLong(1, MAX_N, "N");
  inf.readEoln();
  DisjointSetUnion dsu(n);
  for (size_t i = 0; i + 1 < n; i++) {
    size_t u = inf.readUnsignedLong(1, n, "u[" + vtos(i) + "]");
    inf.readSpace();
    size_t v = inf.readUnsignedLong(1, n, "v[" + vtos(i) + "]");
    u--;
    v--;
    ensuref(dsu.join(u, v), "Graph should be a tree");
    inf.readSpace();
    inf.readInt(-MAX_W, MAX_W, "p[" + vtos(i) + "]");
    inf.readSpace();
    inf.readInt(-MAX_W, MAX_W, "q[" + vtos(i) + "]");
    inf.readEoln();
  }
  inf.readEof();
  return 0;
}