#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 228;

struct edge
{
	ll v;
	ll fr;
	ll bk;
};

int n;
vector<edge> g[MAX_N];
bool need[MAX_N];
ll dp[MAX_N];

void dfs(int v, int p)
{
	dp[v] = 0;
	for (int i = 0; i < (int)g[v].size(); ++i)
	{
		int to = g[v][i].v;
		if (to == p) continue;
		dfs(to, v);

		if (need[to])
		{
			dp[v] += dp[to] + g[v][i].fr;
		}
		else
		{
			if (g[v][i].fr + g[v][i].bk >= 0) // as greedy do
				dp[v] += max(0ll, dp[to] + g[v][i].fr + g[v][i].bk);
		}

		need[v] |= need[to];
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif 	

	scanf("%d", &n);
	for (int i = 0; i < n - 1; ++i)
	{
		int v, u;
		ll c1, c2;
		scanf("%d%d%lld%lld", &v, &u, &c1, &c2);
		--v; --u;
		g[v].push_back({(ll)u, c1, c2});
		g[u].push_back({(ll)v, c2, c1});
	}
	
	memset(need, 0, sizeof(need));
	need[n - 1] = true;
	dfs(0, -1);
	printf("%lld\n", dp[0]);

	return 0;
}

