#include <bits/stdc++.h>
using ll = int64_t;
using ld = long double;
using namespace std;

struct Edge {
    Edge() = default;

    Edge(int dest, int p, int q)
        : dest(dest),
          p(p),
          q(q) {
    }

    int dest, p, q;
};

const int MAXN = 200001;
vector <Edge> e[MAXN];
const ll INF = 1ll << 61;
const ll INF2 = INF * 2;

int block;
ll dfs(int v, int p) {
    ll ans = 0;
    for (auto& ed : e[v]) {
        if (ed.dest == p || ed.dest == block) {
            continue;
        }
        ans += max(ll(0ll), dfs(ed.dest, v) + ed.p + ed.q);
    }

    return ans;
}

ll dfs_block(int v, int p, int bl = -1) {
    block = bl;
    return dfs(v, p);
}

vector <int> path;

ll gt(int v, int p) {
    if (v == 1) {
        return dfs_block(v, p);
    }

    for (auto& ed : e[v]) {
        int u = ed.dest;
        if (u == p) {
            continue;
        }

        ll gu = gt(u, v);
        if (gu >= -INF) {
            return gu + ed.q + dfs_block(v, p, u);
        }
    }

    return -INF2;
}


int main() {
#ifdef PAUNSVOKNO
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v, p, q;
        cin >> u >> v >> p >> q;
        e[u].emplace_back(v, p, q);
        e[v].emplace_back(u, q, p);
    }

    ll val = gt(n, -1);
    assert(val >= -INF);
    cout << val << "\n";
}
