#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

int lft = 100000;
const int nmax = 1000 * 1000;

vector<int> s[nmax];
bool big[nmax];

bool comp(int a, int b) {
    if (big[a] == big[b]) {
        return a < b;
    } else {
        return big[a];
    }
}

bool cmp(const vector<int> &a, const vector<int> &b) {
    int len = min((int)a.size(), (int)b.size());
    for (int i = 0; i < len; i++) {
        if (a[i] == b[i]) continue;
        return comp(a[i], b[i]);
    }
    if (a.size() >= b.size()) {
        return false;
    } else {
        return true;
    }
}

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc <= 2) {
        cerr << "Usage: n, maxlen, maxchar, seed" << endl;
        return 1;
    } 
    int n = atoi(argv[1]);
    int maxlen = atoi(argv[2]);
    int maxc = atoi(argv[3]);
    vector<int> hey, pref;
    for (int i = 1; i <= maxc; i++) {
        if (rnd.next(1, 2) == 1) {
            big[i] = true;
        }
        hey.pb(i);
    }
    sort(hey.begin(), hey.end(), comp);
    for (int i = 0; i < n; i++) {
        int len = rnd.next(1, min(maxlen, lft - (n - i - 1)));
        while ((int)pref.size() > len - 1) {
            pref.pop_back();
        }
        lft -= len;
        int del = rnd.next(0, (int)pref.size());
        for (int i = 0; i < del; i++) {
            pref.pop_back();
        }
        while ((int)pref.size() < len) {
            pref.pb(rnd.next(1, maxc));
        }
        s[i] = pref;
    }
    sort(s, s + n, cmp);
    cout << n << " " << maxc << endl;
    for (int i = 0; i < n; i++) {
        cout << s[i].size() << " ";
        for (int j = 0; j < (int)s[i].size(); j++) {
            cout << s[i][j] << (j == (int)s[i].size() - 1 ? "\n" : " ");
        }
    }
    return 0;
}
