#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

vector<char> is_lower;
vector<vector<unsigned>> a;

bool proceed(size_t x, size_t l, size_t r) {
	// cerr << "proceed " << x << " " << l << " " << r << endl;
	if (l >= r) return true;
	bool has_prev = false;
	bool cur_lower = false;
	size_t prev_seg_started;
	for (int i = l; i < r; ++i) {
		if (a[i].size() <= x) continue;
		if (has_prev) {
			if (a[i][x] >= a[i-1][x]) {
				is_lower[a[i][x]] |= cur_lower;
			} else if (!cur_lower) {
				cur_lower = true;
				is_lower[a[i][x]] = true;
			} else {
				return false;
			}
			if (a[i][x] != a[i-1][x]) {
				if (!proceed(x+1, prev_seg_started, i)) return false;
				prev_seg_started = i;
			}
		} else {
			prev_seg_started = i;
		}
		has_prev = true;
		cur_lower |= is_lower[a[i][x]];
	}
	if (has_prev) {
		if (!proceed(x+1, prev_seg_started, r)) return false;
	}
	return true;
}

bool less_or_equal(vector<unsigned> &a, vector<unsigned> &b) {
	for (int x = 0; x < a.size() && x < b.size() ; ++x) {
		if (std::tie(is_lower[a[x]], a[x]) != std::tie(is_lower[b[x]], b[x])) {
			return std::tie(is_lower[a[x]], a[x]) < std::tie(is_lower[b[x]], b[x]);
		}
	}
	return a.size() <= b.size();
}

bool check() {
	for (int i = 1; i < a.size(); ++i) {
		if (!less_or_equal(a[i-1], a[i])) return false;
	}
	return true;
}

int main(void) {
	size_t n;
	unsigned m;
	cin >> n >> m;
	a.resize(n);
	is_lower.resize(m);
	for (auto& v : a) {
		size_t sz;
		cin >> sz;
		v.resize(sz);
		for (auto& it : v) {
			cin >> it;
			--it;
		}
	}
	proceed(0, 0, n);
	if (check()) {
		cout << "Yes" << endl;
		vector<unsigned> ans;
		for (size_t x = 0; x < m; ++x) {
			if (!is_lower[x]) ans.push_back(x);
		}
		cout << ans.size() << endl;
		for (auto it : ans) cout << it+1 << " ";
		cout << endl;
	} else {
		cout << "No" << endl;
	}
}
