// Copyright (C) 2016 Sayutin Dmitry.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 3

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; If not, see <http://www.gnu.org/licenses/>.


#include "testlib.h"
#include <stdint.h>

const int max_n = 200 * 1000;

int main(int argc, char** argv) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readEoln();
    auto line = inf.readWord();
    inf.readEoln();
    inf.readEof();

    ensuref(int(line.size()) == n, "String doesn't match it's length");
    
    for (size_t i = 0; i != line.size(); ++i)
        ensuref(line[i] == 'r' or line[i] == 'b' or line[i] == '?', "String must contain only \"rb?\"");
    
    return 0;
}
